

#pragma once

#include "CoreMinimal.h"
//I have added SocketClient to SocketClientCPPDemo.Build.cs. Then close VisualStudio and start "Generate VS Project files" to let VS find the include.
#include "SocketClient.h"
#include "GameFramework/GameModeBase.h"
#include "SocketClientCPPDemoGameModeBase.generated.h"

/**
 * 
 */
UCLASS()
class SOCKETCLIENTCPPDEMO_API ASocketClientCPPDemoGameModeBase : public AGameModeBase
{
	GENERATED_BODY()

public:

	virtual void BeginPlay() override;

	//The EndPlay function is never triggered in my tests. That's why I use UnregisterAllComponents and the flag isEndPlay
	virtual void UnregisterAllComponents(bool bForReregister = false) override;

	UFUNCTION()
		void socketClientTCPConnectionEvent(const bool success, const FString message, const FString clientConnectionID);
	UFUNCTION()
		void receiveTCPMessageEvent(const FString message, const TArray<uint8>& byteArray, const FString clientConnectionID);

	UFUNCTION()
		void socketClientUDPConnectionEvent(const bool success, const FString message, const FString clientConnectionID);
	UFUNCTION()
		void receiveUDPMessageEvent(const FString message, const TArray<uint8>& byteArray, const  FString IP, const int32 port, const FString clientConnectionID);

private:
	bool isEndPlay = true;
	FString connectionIdGlobalTCP;
	FString connectionIdGlobalUDP;
};
